import 'package:flutter/cupertino.dart';
import 'package:google_applovin_unity_ads/google_applovin_unity_ads.dart';

/// Listens for app foreground events and shows app open ads.
class AppLifecycleReactor {
  final AppOpenAdManager appOpenAdManager;

  AppLifecycleReactor({required this.appOpenAdManager});

  void listenToAppStateChanges(BuildContext context) {
    AppStateEventNotifier.startListening();
    AppStateEventNotifier.appStateStream
        .forEach((state) => _onAppStateChanged(state, context));
  }

  void _onAppStateChanged(AppState appState, BuildContext context) {
    if (appState == AppState.foreground) {
      appOpenAdManager.showAdIfAvailable(context);
    }
  }
}
